config/routes.rb
Rails.application.routes.draw do

  root to: "static#home"
  
  concern :paginatable do
    get '(page/:page)', :action => :index, :on => :collection
  end
  
  concern :searchable do
    get 'search/:search', :action => :search, :on => :collection, as: 'search_result'
    post 'search/', :action => :search, :on => :collection, :as => 'search'
  end
  
  concern :search_paginatable do
    get 'search/:search/(page/:page)', :action => :search, :on => :collection
  end
  
  devise_for :users, path: 'account'
  get '/' => 'static#home', :as => 'home'
  get '/team' => 'static#team', :as => 'team'
  get '/deine-chance' => 'static#youtube', :as => 'deine_chance'
  get '/youtube' => 'static#youtube', :as => 'youtube'
  get '/bewerbung' => 'static#application', :as => 'application'
  get '/team/history' => 'static#team_history', :as => 'team_history'
  get '/maps' => 'static#maps', :as => 'maps'
  get '/premium' => 'static#premium', :as => 'premium'
  get '/statistik' => 'static#statistic', :as => 'statistic'
  get '/kontakt' => 'static#contact', :as => 'contact'
  get '/impressum' => 'static#imprint', :as => 'imprint'
  get '/agb' => 'static#tos', :as => 'tos'
  
  resources :chatlogs, only: [:show]

  resources :users, path: 'players', except: [:edit, :update], param: :name, :concerns => [:searchable] do
    get 'statistic'
    get 'youtube'
  end
  
  resources :users, path: 'players/uuid/', only: [:edit]
  resources :users, path: 'players', only: [:update]
  
  get '/players/uuid/:id/' => 'users#show'
  get '/players/uuid/:id/statistic' => 'users#statistic'
  get '/players/uuid/:id/youtube' => 'users#youtube'
  
  get 'sitemap.xml' => 'sitemap#index'
  
  namespace :dashboard, layout: 'dashboard' do
    get '/' => 'users#online', :as => 'dashboard'
    resources :chatlogs, :concerns => [:searchable, :search_paginatable, :paginatable]
    resources :users, path: 'players', :concerns => [:searchable, :search_paginatable, :paginatable] do
      get 'online', :on => :collection
      get 'chatlogs'
    end
  end
  
end

app/models/user.rb
# require 'uuidtools'

class User
  include Mongoid::Document
  
  RANKS = {"§9" => "Builder", "§3" => "Developer", "§4" => "Admin", "§5" => "YouTube", "§6" => "Premium", "§c" => "Moderator"}
  COLORS = {"§9" => "5555FF", "§3" => "00AAAA", "§4" => "AA0000", "§5" => "AA00AA", "§6" => "FFAA00", "§c" => "FF5555"}
  
  paginates_per 50
  
  store_in collection: "users"
  
  # Include default devise modules. Others available are:
  # :recoverable, :trackable, :registerable, :confirmable, :lockable, :timeoutable, :validatable and :omniauthable
  devise :database_authenticatable, :rememberable

  ## Database authenticatable
  field :encrypted_password, type: String, default: ""

  ## Recoverable
  # field :reset_password_token,   type: String
  # field :reset_password_sent_at, type: Time

  ## Rememberable
  field :remember_created_at, type: Time

  ## Trackable
  # field :sign_in_count,      type: Integer, default: 0
  # field :current_sign_in_at, type: Time
  # field :last_sign_in_at,    type: Time
  # field :current_sign_in_ip, type: String
  # field :last_sign_in_ip,    type: String

  ## Confirmable
  # field :confirmation_token,   type: String
  # field :confirmed_at,         type: Time
  # field :confirmation_sent_at, type: Time
  # field :unconfirmed_email,    type: String # Only if using reconfirmable

  ## Lockable
  # field :failed_attempts, type: Integer, default: 0 # Only if lock strategy is :failed_attempts
  # field :unlock_token,    type: String # Only if unlock strategy is :email or :both
  # field :locked_at,       type: Time
  
  field :_id
  field :name
  field :displayName
  field :lastSeen
  field :online
  field :groups
  field :youtube_id
  field :ip
  field :banHistory
  field :lastLocation
  embeds_many :friendships, as: :friendshipable
  
  attr_readonly :_id, :displayName, :lastSeen, :online, :friends
  
  def sorted_friendships
    friendships.sort_by{|friendship| friendship.user.name}
  end
  
  def mccolorcode
    /(§[0-9|a,b,c,d,e,f])/.match(displayName)
  end
  
  def rank
    if !mccolorcode.nil?
      return RANKS[mccolorcode.to_s]
    end
  end
  
  def colorcode
    if !mccolorcode.nil?
      return COLORS[mccolorcode.to_s]
    end

  end
  
  def has_role?(role)
   self.groups ||= []
   groups.any?{ |s| s.casecmp(role.to_s) == 0 }
  end
  
  def is_banned
    if self.banHistory
      if self.banHistory.last['action'] != 0 && self.banHistory.last['until'].to_datetime > Time.now
        return true
      end
    end
    return false
  end
  
  def statistic
    return Bedwarsstatistic.where(uuid: self._id).first
  end
  
end

app/controllers/dashboard/chatlogs_controller.rb
class Dashboard::ChatlogsController < ApplicationController
  before_action :authenticate_user!
  before_filter :verify_access
  load_and_authorize_resource
  
  def index
		@chatlogs = Chatlog.order_by(:created => 'desc').page params[:page]
  end
  
  def search
    if params[:search].empty?
      redirect_to chatlogs_path()
    elsif params[:search] && request.post?
      redirect_to search_result_dashboard_chatlogs_path(params[:search])
    elsif params[:search] && request.get?
      @chatlogs = Chatlog.where({_id: /.*#{params[:search]}.*/i }).order_by(:created => 'desc').page params[:page]
      if @chatlogs.count == 1
        redirect_to dashboard_chatlog_path(@chatlogs.first.id)
      else
        render 'index'
      end
		end
	end
  
	def show
    @chatlog = Chatlog.find_by(_id: params[:id])
    if @chatlog.nil?
      redirect_back(fallback_location: home_path, :flash => { :error => "Chatlog nicht gefunden" })
    end
	end
	
	private
  def verify_access
    redirect_back(fallback_location: home_path) unless can? :access, :dashboard
  end
end

app/controllers/dashboard/users_controller.rb
class Dashboard::UsersController < ApplicationController
  before_action :authenticate_user!
  before_filter :verify_access
  load_and_authorize_resource
  
  def index
    @users = User.order_by(:name => 'asc').page params[:page]
  end
  
  def online
    @users = User.where({:online => true }).order_by(:name => 'asc').page params[:page]
    
    user_ips = []
    @users.each{|player| user_ips << player.ip}

    @second_account_ip_groups = User.where({:ip.in => user_ips}).order_by(:ip => 'asc', :lastSeen => 'desc').group_by{|player| player.ip}
  end
  
  def search
    if params[:search].empty? || (params[:search].to_s.length < 3 && !(can? :index, User))
      redirect_back(fallback_location: home_path, :flash => { :error => "Suchbegriff zu kurz" })
    elsif params[:search] && request.post?
      redirect_to search_result_dashboard_users_path(params[:search])
    elsif params[:search] && request.get?
      @users = User.where({
        "$or" => [
          {_id: "#{params[:search]}" },
          {name: /.*#{params[:search]}.*/i }
        ]
      }).order_by(:name => 'asc').page params[:page]
      if @users.count == 1
        redirect_to dashboard_user_path(@users.first)
      else
        render 'index'
      end
		end
	end
  	
	def show
      @user = User.find_by(id: params[:id])
    if @user.nil?
      redirect_back(fallback_location: home_path, :flash => { :error => "Spieler nicht gefunden" })
    end
	end
	
	def chatlogs
    @user = User.find_by(id: params[:user_id])
    if @user.nil?
      redirect_back(fallback_location: home_path, :flash => { :error => "Spieler nicht gefunden" })
    end
    @chatlogs = Chatlog.where({"messages.user_id": @user._id }).order_by(:created => 'desc').page params[:page]
	end
	
	def edit
    if params.has_key?(:id)
      @user = User.find_by(id: params[:id])
    elsif params.has_key?(:name)
      @user = User.find_by(name: params[:name])
    end
    if @user.nil?
      redirect_back(fallback_location: home_path, :flash => { :error => "Spieler nicht gefunden" })
    end
	end
	
	def update
	
		if params.has_key?(:id)
      @user = User.find_by(id: params[:id])
    elsif params.has_key?(:name)
      @user = User.find_by(name: params[:name])
    end
    if @user.nil?
      redirect_back(fallback_location: home_path, :flash => { :error => "Spieler nicht gefunden" })
    end
		if @user.update_without_password(user_params)
			redirect_to user_path(@user.name), :flash => { :success => "Spieler gespeichert" }
		else
      flash[:error] = ["Fehler beim Speichern"]
      @user.errors.full_messages.each do |msg|
        flash[:error] << msg
      end
			render 'edit'
		end
	end
	
	private
		def user_params
			params.require(:user).permit(:youtube_id)
		end
		
  def verify_access
    redirect_back(fallback_location: home_path) unless can? :access, :dashboard
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :authenticate_user!, only: [:edit]
  load_and_authorize_resource
  
  def search
    if params[:search].empty? || (params[:search].to_s.length < 3 && !(can? :index, User))
      redirect_back(fallback_location: home_path, :flash => { :error => "Suchbegriff zu kurz" })
    elsif params[:search] && request.post?
      redirect_to search_result_users_path(params[:search])
    elsif params[:search] && request.get?
      @users = User.where({
        "$or" => [
          {_id: "#{params[:search]}" },
          {name: /.*#{params[:search]}.*/i }
        ]
      }).order_by(:name => 'asc').page params[:page]
      if @users.count == 1
        redirect_to user_path(@users.first.name)
      else
        redirect_back(fallback_location: home_path, :flash => { :error => "Spieler nicht gefunden" })
      end
		end
	end
  
  def statistic
    if params.has_key?(:id)
      @user = User.find_by(id: params[:id])
    elsif params.has_key?(:user_name)
      @user = User.find_by(name: params[:user_name])      
      #@lhplayer = Leaderheadsplayer.where(uuid: @user._id).first
      #@lhmonthlystatistic = @lhplayer.leaderheadsmonthlystatistics.group_by{|statistic| [statistic.year, statistic.month]}.sort_by{|statistic| [0, 1]}.reverse_each
      #@lhdailystatistic = @lhplayer.leaderheadsdailystatistics.group_by{|statistic| statistic.day}.sort_by{|statistic| 0}.reverse_each
    end
    if @user.nil?
      redirect_back(fallback_location: home_path, :flash => { :error => "Spieler nicht gefunden" })
    else
      @statistic = Bedwarsstatistic.where(uuid: @user._id).first
    end
	end
	
	def show
    if params.has_key?(:id)
      @user = User.find_by(id: params[:id])
    elsif params.has_key?(:name)
      @user = User.find_by(name: params[:name])
    end
    if @user.nil?
      redirect_back(fallback_location: home_path, :flash => { :error => "Spieler nicht gefunden" })
    end
	end
	
	def youtube
    if params.has_key?(:id)
      @user = User.find_by(id: params[:id])
    elsif params.has_key?(:user_name)
      @user = User.find_by(name: params[:user_name])
    end
    if @user.nil?
      redirect_back(fallback_location: home_path, :flash => { :error => "Spieler nicht gefunden" })
      return
    end
    if @user.youtube_id.nil? || @user.youtube_id.empty?
      redirect_back(fallback_location: home_path, :flash => { :error => "YouTube nicht gefunden" })
      return
    end
    @channel = Yt::Channel.new id: @user.youtube_id
    begin
      @channel.title # Check if channel exists
      @videos = Yt::Collections::Videos.new
      @videos.where(channel_id: @user.youtube_id, q: "bedwars.network")
    rescue => e
      redirect_back(fallback_location: home_path, :flash => { :error => "YouTube nicht gefunden" })
    end 
    
	end
	
	def edit
    if params.has_key?(:id)
      @user = User.find_by(id: params[:id])
    elsif params.has_key?(:name)
      @user = User.find_by(name: params[:name])
    end
    if @user.nil?
      redirect_back(fallback_location: home_path, :flash => { :error => "Spieler nicht gefunden" })
    end
	end
	
	def update
	
		if params.has_key?(:id)
      @user = User.find_by(id: params[:id])
    elsif params.has_key?(:name)
      @user = User.find_by(name: params[:name])
    end
    if @user.nil?
      redirect_back(fallback_location: home_path, :flash => { :error => "Spieler nicht gefunden" })
    end
		if @user.update_without_password(user_params)
			redirect_to user_path(@user.name), :flash => { :success => "Spieler gespeichert" }
		else
      flash[:error] = ["Fehler beim Speichern"]
      @user.errors.full_messages.each do |msg|
        flash[:error] << msg
      end
			render 'edit'
		end
	end
	
	private
		def user_params
			params.require(:user).permit(:youtube_id, :name)
		end
end

app/views/dashboard/users/_actions.html.slim
- content_for :actions do
  - if (can? :update, User) || (can? :index, Chatlog)
    li
      a.subheader
        => User.model_name.human
        = @user.name
    - if can? :index, Chatlog
      li class=('active' if (params[:controller] == "dashboard/chatlogs"))
        = link_to(dashboard_user_chatlogs_path(@user)) do
          = content_tag(:i, 'attach_file', class: 'material-icons')
          = Chatlog.model_name.human(count: 2)
    - if can? :update, User
      li class=('active' if (params[:controller] == "users" && params[:action] == "edit" && params[:id] == @user.id))
        = link_to(edit_dashboard_user_path(@user)) do
          = content_tag(:i, 'mode_edit', class: 'material-icons')
          | Bearbeiten

app/views/dashboard/users/_header.html.slim
.row
  .col.xs12
    .card.collection.z-depth-0
      .card-content.center-align
        h1 style=("text-transform: none") = @user.name
        - if @user.rank
          = content_tag(:div, class: "chip white-text", style: "background-color: ##{@user.colorcode}") do
            = @user.rank
        - if @user.online
          .chip.green.white-text
            | online

app/views/dashboard/users/_searchbar.html.slim
- content_for :searchbar do
  li.search
    .search-wrapper.card
      = form_tag(search_dashboard_users_path(), :method => 'post') do
        = text_field_tag :search, params[:search]
        = content_tag(:i, "search", class: "material-icons")
    .clearfix

app/views/dashboard/users/_user.html.slim
tr
  td
    = link_to dashboard_user_path(user) do
      span.title = user.name
  td
    - if user.online
      .label.green.white-text
        - if user.lastLocation
          = user.lastLocation
        - else
          | online 
    - elsif user.lastSeen
      = user.lastSeen.in_time_zone("Berlin").strftime("%d.%m.%Y - %H:%M Uhr")
  td
    - if user.statistic
      = user.statistic.games
    - else
      | 0
  td
    - if user.rank
      => content_tag(:span, class: "label white-text", style: "background-color: ##{user.colorcode}") do
        = user.rank
    - if user.banHistory
      - if user.is_banned
        .label.red.white-text
          | gebannt
      - else
        span.label.orange.white-text
          | Hat Bannhistorie

app/views/dashboard/users/chatlogs.html.slim
- title(@user.name)
= render("actions")
= render("searchbar")
.row
  = render("header")
.row
  .col.xs12
    - if @chatlogs.empty?
      .card.collection.z-depth-0
        .card-content
          | Keine Chatlogs gefunden...
    - else
      .center-align
        = paginate @chatlogs
      ul.collection
        - @chatlogs.each do |chatlog|
          li.collection-item.avatar
            = link_to dashboard_chatlog_path(chatlog) do
              - if chatlog.server.start_with?("Lobby")
                = content_tag(:i, "home", class: "material-icons green circle")
              - elsif chatlog.server.start_with?("BW")
                = content_tag(:i, "games", class: "material-icons red circle")
              - else
                = content_tag(:i, "attachment", class: "material-icons circle")
              - if params[:search]
                  span.title = highlight(chatlog._id, params[:search])
              - else
                span.title = chatlog._id
              p
                span.grey-text.lighten-2
                  = chatlog.server
                  |  - 
                  = chatlog.created.in_time_zone("Berlin").strftime("%d.%m.%Y - %H:%M Uhr")
                br
                span.grey-text.lighten-2
                  = chatlog.chatlogmessages.count
                  |  Elemente
              .secondary-content
                = content_tag(:i, "attachment", class: "material-icons")
        .center-align
          = paginate @chatlogs

app/views/dashboard/users/edit.html.slim
- title(@user.name)
= render("actions")
= render("searchbar")
.row
  = render("header")
.row
  = form_for @user do |f|
    .col.xs12
      .card.collection.z-depth-0
        .card-content
          .row
            .input-field.col.xs12
              = f.label :youtube_id
              = f.text_field :youtube_id, class: 'validate'
            
    .col.s12
      .card.collection.z-depth-0
        .card-content
          => f.submit :class => "waves-effect waves-light btn green"
          = link_to "Zurück", user_path(@user.name), data: { confirm: t("helpers.submit.cancel_update", model: User.model_name.human) }, :class => "waves-effect waves-light btn red"

app/views/dashboard/users/index.html.slim
- title("Spieler")
= render("searchbar")
.row
  .col.xs12
    .card.collection.z-depth-0
      .card-content.center-align
        h1 = User.model_name.human(count: 2)
.row
  .col.xs12
    .card.collection.z-depth-0
      .card-content
        - if @users.empty?
              | Keine Spieler gefunden...
        - else
          .center-align
            = paginate @users
          table
            thead
              th Spielername
              th Zuletzt gesehen
              th Gespielte Spiele
              th
            tbody  
              = render @users
          .center-align
            = paginate @users

app/views/dashboard/users/online.html.slim
- title("Spieler Online")
= render("searchbar")
.section
  .row
    .col.xs12
      ul.collection.with-header
        li.collection-header.center-align
          h1
            => User.model_name.human(count: 2)
            | online
.section
  .row
    .col.xs12
      .card.collection.z-depth-0
        .card-content
          - if @users.empty?
            | Keine Spieler online...
          - else
            table
              thead
                th Spielername
                th Zuletzt gesehen
                th Gespielte Spiele
                th
              tbody  
                = render @users
- if !@users.empty?
  .divider
  .section
    .row
      .col.xs12
        ul.collection.with-header
          li.collection-header.center-align
            h4 Etwaige Zweitaccounts
    .row
      - @second_account_ip_groups.each do |ip, users|
        - if users.count > 1
          .col.xs12
            .card.collection.z-depth-0
              .card-content
                - splitted_ip = ip.split('.')
                h5 #{splitted_ip[0]}.#{splitted_ip[1]}.#{splitted_ip[2]}.XXX
                table
                  thead
                    th Spielername
                    th Zuletzt gesehen
                    th Gespielte Spiele
                    th
                  tbody
                  = render users

app/views/dashboard/users/show.html.slim
- title(@user.name)
= render("actions")
= render("searchbar")
.row
  = render("header")
- if !@user.friendships.empty?
  .row
    .col.xs12
      .card.collection.z-depth-0
        .card-content
          span.card-title Freunde
          .center-align
          table
            thead
              th Spielername
              th Zuletzt gesehen
              th Gespielte Spiele
              th
            tbody    
              - @user.sorted_friendships.each do |friendship|
                - if friendship.status?
                  = render friendship.user